let sessionNumber = 9;
require('geckodriver');
// Generated by Selenium IDE
const { Builder, By, Key, until } = require('selenium-webdriver')
const firefox = require('selenium-webdriver/firefox');
const { performance } = require('perf_hooks');
const assert = require('assert');
const fs = require('fs');
const path = require('path');
const chai = require('chai');
const expect = chai.expect;

const data = fs.readFileSync('./test/grading.json');
const jsonData = JSON.parse(data);

if(!jsonData.gradedTest.s09){

	try {

    if (!fs.existsSync('./sessions/frontend/s09/activity/index.html')) {
			throw new Error('File not found');
		  }

      //Automated Grading Integration
      // Variable to store passing unit test scores for the session
      let passingTests = 0;
      // Variable to store total number of session unit tests
      let totalTests = 0;


      function parsePixels(value) {
          return parseFloat(value.replace('px', ''));
        }

      describe('s09', function() {

        this.timeout(30000);
        const timeout = 10000;
        let driver;
        let vars;

        let internalCssTestPassed = false;

        let startTime;
        let errors = [];
        before(async function() {
          startTime = performance.now();
          // Any setup code you need to run before the tests start
          driver = await new Builder().forBrowser('firefox').setFirefoxOptions(options).build()
        });
        
        const options = new firefox.Options();
        options.headless();
  
        options.setPreference('browser.download.manager.showWhenStarting', false);
        options.setPreference('browser.download.manager.useWindow', false);
  
        beforeEach(async function() {

          totalTests += 1;
          vars = {}
        })
  
        afterEach(function(){
  
          if(this.currentTest.state === "passed"){
            passingTests += 1;
          }
  
          process.removeAllListeners(); 

          if (this.currentTest.state === 'failed') {
            errors.push({
                test: this.currentTest.title,
                feedback: this.currentTest.err.message
            });
        }
  
        })

        it('check universal css reset', async function() {
          const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

            // Find the pre-footer section by id
            const html = await driver.findElement(By.css('html'));
            const margin = await html.getCssValue('margin');
            const padding = await html.getCssValue('padding');
            const boxSizing = await html.getCssValue('box-sizing');

            expect(margin).to.equal("0px","no css reset");
            expect(padding).to.equal("0px","no css reset");
            expect(boxSizing).to.equal("border-box","no css reset");
            
        });

        it('check page does not use default fonts', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const bodyElement = await driver.findElement(By.css('body'));
            const fontFamily = await bodyElement.getCssValue('font-family');

            expect(fontFamily).to.not.include('Times New Roman',"Body font-family includes Times New Roman.");
            expect(fontFamily).to.not.include('Arial',"Body font-family includes Arial.");
  
        });


        it('check nav properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const bodyElement = await driver.findElement(By.css('nav'));
            const padding = await bodyElement.getCssValue('padding').then(parsePixels);
            const bgColor = await bodyElement.getCssValue('background-color');
            const align = await bodyElement.getCssValue('text-align');
            
            // Check if navbar position is sticky
            expect(padding).to.be.at.least(1,"Nav has no padding.");
            expect(bgColor).to.not.include('transparent',"Navbar does not have bg color.");
            expect(align).to.include('center',"Navbar text is not center");
            
          });

        it('check nav li properties', async function() {
            const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
            const url = `file://${filePath}`;
            await driver.get(url);
  
            const navLinks = await driver.findElements(By.css('nav ul li'));
            for(let i = 0; i < navLinks.length; i++){
              const type = await navLinks[i].getCssValue('list-style-type');
              const display = await navLinks[i].getCssValue('display');
              const margin = await navLinks[i].getCssValue('margin').then(parsePixels);
              const padding = await navLinks[i].getCssValue('padding').then(parsePixels);

              expect(type).to.include('none','nav li list style type is not none.');
              expect(display).to.include('inline-block','nav li list is not inline-block.');
              expect(margin).to.be.at.least(1,"Nav Li do not have margins.");
              expect(padding ).to.be.at.least(1,"Nav Li do not have paddings.");
            }
  
        });

        it('check landing properties', async function() {
          const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

          const landing = await driver.findElement(By.css('#landing'));
          const bgPosition = await landing.getCssValue('background-position');
          const bgSize = await landing.getCssValue('background-size');
          const img = await landing.getCssValue('background-image');
          const backgroundRepeat = await driver.executeScript(
            'return getComputedStyle(arguments[0]).backgroundRepeat',
            landing
          );

          expect(bgPosition).to.include('50% 50%','#landing bg image is not centered.');
          expect(bgSize).to.include('cover','#landing bg size is not cover');
          expect(backgroundRepeat).to.include('no-repeat','#landing bg image repeats');
          expect(img).to.not.equal('none','#landing bg image not added');

        });

        it('check landing properties', async function() {
          const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
          const url = `file://${filePath}`;
          await driver.get(url);

          const landing = await driver.findElement(By.css('#landing'));
          const bgPosition = await landing.getCssValue('background-position');
          const bgSize = await landing.getCssValue('background-size');
          const img = await landing.getCssValue('background-image');
          const backgroundRepeat = await driver.executeScript(
            'return getComputedStyle(arguments[0]).backgroundRepeat',
            landing
          );

          expect(bgPosition).to.include('50% 50%','#landing bg image is not centered.');
          expect(bgSize).to.include('cover','#landing bg size is not cover');
          expect(backgroundRepeat).to.include('no-repeat','#landing bg image repeats');
          expect(img).to.not.equal('none','#landing bg image not added');

        });

      it('check landing h1', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const landingH1 = await driver.findElement(By.css('#landing h1'));
        const paddingTop = await landingH1.getCssValue('padding-top').then(parsePixels);
        const fontSize = await landingH1.getCssValue('font-size').then(parsePixels);

        expect(paddingTop).to.be.at.least(1,'#landing h1 does not have padding top');
        expect(fontSize).to.be.at.least(16,'#landing h1 font size is too small');

      });

      it('check landing h3', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const landingH3 = await driver.findElement(By.css('#landing h3'));
        const margin = await landingH3.getCssValue('margin').then(parsePixels);

        expect(margin).to.be.at.least(1,'#landing h3 does not have margin on all sides');

      });

      it('check landing button', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const landingBtn = await driver.findElement(By.css('#landing button'));
        const padding = await landingBtn.getCssValue('padding').then(parsePixels);
        const backgroundColor = await landingBtn.getCssValue('background-color')
        const borderClr = await landingBtn.getCssValue('border-color');
        const borderWdt = await landingBtn.getCssValue('border-width').then(parsePixels);
        const borderSty = await landingBtn.getCssValue('border-style');
        const borderRadius = await landingBtn.getCssValue('border-radius').then(parsePixels);
        
        expect(padding).to.be.at.least(1,"landing button padding is not set to at least .8rem");
        expect(backgroundColor).to.not.include("rgb(233, 233, 237)","landing button bg color is set to browser default");
        expect(borderClr).to.not.include("rgb(227, 227, 227)","landing button border color is default");
        expect(borderWdt).to.be.at.least(2,"landing button does not have 2px border");
        expect(borderSty).to.not.include("outset","landing button border style is default.");
        expect(borderRadius).to.be.at.least(1,"landing button does not have enough border-radius");
        

        //expect(margin).to.be.at.least(1,'#landing h3 does not have margin on all sides');

      });

      it('check #hot div', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const hotSection = await driver.findElement(By.css('#hot'));
        const align = await hotSection.getCssValue('text-align')
        
        expect(align).to.equal("center","#hot element text-alignment is not centered.");

      });

      it('check #hot h2', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const hotSectionH2 = await driver.findElement(By.css('#hot h2'));
        const marginTop = await hotSectionH2.getCssValue('margin-top').then(parsePixels)
        const marginBottom = await hotSectionH2.getCssValue('margin-bottom').then(parsePixels)
        
        expect(marginTop).to.be.at.least(1,"#hot h2 element does not have enough margin top");
        expect(marginBottom).to.be.at.least(1,"#hot h2 element does not have enough margin bottom");

      });

      it('check #hot ul li', async function() {
        const filePath = path.join(__dirname, '..','sessions','frontend','s09','activity','index.html');
        const url = `file://${filePath}`;
        await driver.get(url);

        const liCategories = await driver.findElements(By.css('#hot ul li'));

        for(let i = 0; i < liCategories.length; i++){
          const marginL = await liCategories[i].getCssValue('margin-left').then(parsePixels)
          const marginR = await liCategories[i].getCssValue('margin-right').then(parsePixels)
          const display = await liCategories[i].getCssValue('display')
          const borderRadius = await liCategories[i].getCssValue('border-radius').then(parsePixels)
          const listStyle = await liCategories[i].getCssValue('list-style-type')
          const borderClr = await liCategories[i].getCssValue('border-color');
          const borderWdt = await liCategories[i].getCssValue('border-width').then(parsePixels);
          const borderSty = await liCategories[i].getCssValue('border-style');

          expect(display).to.include("inline-block","#hot ul li is not displayed as inline-block");
          expect(borderRadius).to.be.at.least(1,"#hot ul li border-radius is not at least 10px");
          expect(listStyle).to.include("none","#hot ul li list style type is not set to none.");
          expect(marginL).to.be.at.least(1,"#hot ul li does not have enough margin left");
          expect(marginR).to.be.at.least(1,"#hot ul li does not have enough margin right");
          expect(borderClr).to.not.include("rgb(227, 227, 227)","#hot ul li border color is default");
          expect(borderWdt).to.be.at.least(1,"#hot ul li does not have 2px border");
          expect(borderSty).to.not.include("outset","#hot ul li border style is default.");

        }

      });

      after(async function () {

        const endTime = performance.now();
        const totalTime = (endTime - startTime) / 1000; // Convert to seconds
        console.log(`Total time taken: ${totalTime} seconds`);
        
        
        global.gradesObject["s09"] = {
          grade: `${passingTests/totalTests >= 0.75 ? "P" : "F"}`,
          score: `${passingTests}/${totalTests}`,
          feedback: errors.length ? errors : "No Errors"
        }
        
        jsonData.gradedTest.s09 = true;
        await fs.writeFileSync('./test/grading.json', JSON.stringify(jsonData,null,4));
        
        await driver.quit(); 
      });

    })	

	
    } catch (err) {
      if(err.code === "MODULE_NOT_FOUND" || err.message === "File not found"){
        console.error(`s${sessionNumber} cannot be found. Check activity folder.`);
      } else {
        console.log(err)
      }
    }
} else {
	console.log("s09 - Tested");
}






